#import <driverkit/IODeviceInspector.h>
#import <driverkit/IODeviceMaster.h>
#import <objc/NXBundle.h>
#import <appkit/appkit.h>
#import "MuxParm.h"

#ifdef MuxInspector

@interface Mux:IODeviceInspector
{
    id		muxInspector;	/* The inspector view	*/
    id		port1Size;
    id		port2Size;
    id		port3Size;
    id		port4Size;
    id		port5Size;
    id		port6Size;
    id		port7Size;
    id		port8Size;	/* Size of the Multiplex Register */
    id		port0Address;
    id		port1Address;
    id		port2Address;
    id		port3Address;
    id		port4Address;
    id		port5Address;
    id		port6Address;
    id		port7Address;
    id		port8Address;	/* Address of the Multiplex Register */
    id		multiPanel;

    id		muxAddressSelector;
    id		muxAddressMinusButton;
    id		muxAddressPlusButton;

    /* int		portRangeLength;
    NXStringTable *	table;		/* Passed in during setTable	*/
    IODeviceMaster *	devMaster;	/* Used to get infor to the driver */
    IOObjectNumber	myTag;

    IODeviceInspector *	devInspector;

    NXRect	originalViewSize;
    char	portIndex;
    char	muxIndex;
    char	sizeIndex[NTTY];
    unsigned	sizeBuffer[NTTY];
    unsigned	lowatBuffer[NTTY];
    unsigned	hiwatBuffer[NTTY];
    unsigned	FIFOIndex[NTTY];
}

- loadMainNibFile;
- enterFIFO : sender;
- enterSelection : sender;
- enterSize : sender;
- minusBuffer : sender;
- plusBuffer : sender;
- displaySize : (int)port;
- enterMultiplexorStyle : sender;
- minusAddress : sender;
- plusAddress : sender;
- displayAddress : (int)port;
- setSize : sender;
- setBufferSize : (int)port;
- setBufferHiwat : (int)port;
- setBufferLowat : (int)port;
- (int)getUnsignedIntFromString : (char *)key
		       argument : (unsigned int *)val;
- (int)getHexIntFromStringPort : (int)port
			   key : (char *)key
		      argument : (unsigned int *)val;
- unsetHexIntFromStringPort : (int)port
			key : (char *)key;
- setHexIntFromStringPort : (int)port
		      key : (char *)key
		 argument : (int)val;
- free;
- setTable: (NXStringTable *)instance;
- (View *)inspectionView;
- resourcesChanged : (IOResources *)rsrc;
#ifdef STANDALONE
- rangeDidChange:sender;
- setNumInterrupts : (int)numInterrupts
       numChannels : (int)numChannels
   portRangeLength : (int)numPorts
 memoryRangeLength : (int)numAddresses;
#endif
@end
#endif
