#import "../MuxParm.h"
#import <driverkit/IODevice.h>
#import <driverkit/IODirectDevice.h>
#import <driverkit/i386/directDevice.h>
#import <driverkit/i386/IOEISADeviceDescription.h>
#import <driverkit/IODeviceDescription.h>
#import <driverkit/IOConfigTable.h>

@interface Mux : IODirectDevice

+ (BOOL) probe : deviceDescription;
- (BOOL) preInitHardware : deviceDescription;
- (BOOL) postInitHardware : deviceDescription
		    upper : (id) probe ;
- (BOOL) getUnsignedIntFromDescriptionString : deviceDescription
				    argument : (unsigned int *)arg
					name : (char *)str;
- (unsigned) getInstance: deviceDescription;
#ifdef IF_IODevice_Worked
- (BOOL) getHandler : (IOEISAInterruptHandler *)handler
	      level : (unsigned int *)ipl
	   argument : (unsigned int *)arg
       forInterrupt : (unsigned int)localInterrupt;
#endif
- (IOReturn) getIntValues : (unsigned int *)values
	     forParameter : (IOParameterName) parameter
		    count : (unsigned int *) count;
#ifdef SerialPorts_TEST
- (IOReturn) setIntValues : (unsigned int *)values
	     forParameter : (IOParameterName) parameter
		    count : (unsigned int *) count;
- (IOReturn) acquireUnit : (unsigned)unit
		     for : (IOParameterName) parameter
	      callbackId : (id) id
	       deviceTag : (unsigned)tag;
- (IOReturn) bufferParameters ;
- (IOReturn) postReceiveBuffer : (unsigned) unit
		 maxDataLength : (unsigned) length
		     bufferTag : (unsigned) tag
			vmTask : (id) id
		       forUnit : (unsigned) Unit;
- (IOReturn) setStateEnable : (unsigned) unit
		    forUnit : (unsigned) Unit;
#endif
@end
