/*
 *	Undocumented kernel interrupt handling routines within NeXT's mach
 *	operating system. Typically, one would use ivect, iunut and intpri
 *	structures, but they hid these tables within these routines (the
 *	tables are all meshed together and only have the IRQs in them, they
 *	placed a set of hard coded interrupt entry points to index into these
 *	tables perhaps in an effort to reduce interrupt overhead in light of
 *	the typically object oriented environment they set up for driverKit).
 *	Like a DOS dweeb, I decided to use these undocumented points that I
 *	am sure will not be in the next version of the OS ...
 *
 *	Author: Mark Salyzyn	mark@ve6mgs.ampr.ab.ca	January 9 1994
 *	Disclamer: This stuff will not work, so don't even think about blaming
 *	me for it's failures. Any consequential damage resulting from the
 *	use of this code is to be blamed on the position of Saturn, and not
 *	me. Anything that makes this stuff work better will be gladly accepted!
 *	Update: Mark Salyzyn	Tried to add support for 3.1 Version of
 *	NeXTSTEP, it has failed the test so far ...
 */

#if NeXT	/* 3.1 (_NX_KERNEL=310) and 3.2 versions of NeXTSTEP */
# ifndef _NX_KERNEL
#  define _NX_KERNEL	320
# endif
/*
 *	This routine is required to register the Interrupt Handler to the
 *	internal Kernel Services. We will be overwriting the entry in the
 *	Kernel, and have no ability to chain interrupts, or save the previous
 *	state of the entry with just this routine.
 */
 extern int intr_register_irq(		/* Returns NO on failure, YES on OK*/
  int Irq,				/* 0, 1, 3-15, to specify IRQ	   */
  IOEISAInterruptHandler *Handler,	/* The actual handler routine	   */
  dev_t Unit,				/* Argument passed to handler	   */
#if (defined(_NX_KERNEL) && (_NX_KERNEL==310))
  int x,				/* A little gift removed in 3.2	   */
#endif
  unsigned int Ipl);			/* Priority level within interrupt */
/*
 *	This routine is required to unregister the Interrupt Handler to the
 *	internal Kernel Services.
 */
 extern int intr_unregister_irq(	/* Returns NO on failure, YES on OK*/
  int Irq);				/* 0, 1, 3-15, to specify IRQ	   */
/*
 *	This routine is required to enable the interrupt handling and simply
 *	enables the Priority Interrupt Controllers mask bits.
 */
 extern int intr_enable_irq(		/* Returns NO on failure, YES on OK*/
  int Irq);				/* 0, 1, 3-15, to specify IRQ	   */
/*
 *	This routine is required to disable the interrupt handling and simply
 *	mask out the interrupt on the Priority Interrupt Controllers.
 */
 extern int intr_disable_irq(		/* Returns NO on failure, YES on OK*/
  int Irq);				/* 0, 1, 3-15, to specify IRQ	   */
/*
 *	initialization routine for the above system. I will assume for the
 *	moment that we need not call this routine directly.
 */
 extern int intr_initialize();
/*
 *	Now, define some macros for entry into these routine so as to allow
 *	us to handle changes in the NeXT MACH operating system layers.
 */
#if (defined(_NX_KERNEL) && (_NX_KERNEL==310))
# define	REGISTER_INTERRUPT(irq,intr,unit,ipl)	intr_register_irq(irq,intr,unit,0,ipl)
#else
# define	REGISTER_INTERRUPT(irq,intr,unit,ipl)	intr_register_irq(irq,intr,unit,ipl)
#endif
# define	UNREGISTER_INTERRUPT(irq)	intr_unregister_irq(irq)
# define	ENABLE_INTERRUPT(irq)	intr_enable_irq(irq)
# define	DISABLE_INTERRUPT(irq)	intr_disable_irq(irq)
#else
 extern IOEISAInterruptHandler *	ivect[];
 extern unsigned int			iunit[];
 extern unsigned int			intpri[];
 /*
  *	In traditional systems (MACH 3.0 included) the priority interrupt
  *	mask are developed by searching through intpri and generating the
  *	appropriate mask bits directly for each priority level. This assumes
  *	static drivers, so is actually *not* appropriate for our loadable
  *	driver system. We include these macros for completeness and leave it
  *	up to others to correct this for a suitable loadable driver system
  *	developed for their version of the system.
  */

# define	REGISTER_INTERRUPT(irq,intr,unit,ipl) (	\
	ivect[irq] = func,				\
	iunit[irq] = unit,				\
	intpri[irq] = ipl,				\
	YES)
# define	UNREGISTER_INTERRUPT(irq) (		\
	ivect[irq] = nulldev,				\
	iunit[irq] = 0,					\
	intpri[irq] = 0,				\
	YES)
# define	ENABLE_INTERRUPT(irq)	YES
# define	DISABLE_INTERRUPT(irq)	YES
#endif
